/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#include "udm_config.h"
#include <string.h>
#include "udm_uniconv.h"
#include "udm_unidata.h"


static int
udm_wc_mb_sys_int(udm_mbstate_t *ostate, UDM_CHARSET *cs, udm_wc_t wc,
                  unsigned char *s, unsigned char *e, int flags)
{
  if (s + sizeof(int) > e)
    return UDM_CHARSET_TOOSMALL;
  
  memcpy(s, &wc, sizeof(wc));
  return sizeof(wc);
}


static int
udm_mb_wc_sys_int(udm_mbstate_t *istate, UDM_CHARSET *cs, udm_wc_t *pwc,
                  const unsigned char *s, const unsigned char *e, int flags)
{
  if (s + sizeof(udm_wc_t) > e)
    return UDM_CHARSET_TOOFEW(0);
  
  memcpy(pwc, s, sizeof(udm_wc_t));
  return sizeof(udm_wc_t);
}


static UDM_CHARSET_HANDLER udm_charset_handler_sys_int=
{
  udm_mb_wc_sys_int,
  udm_wc_mb_sys_int,
  UdmStrToLower,
  NULL, /* septoken */
  NULL, /* getword */
  NULL, /* crc32lcase */
  NULL, /* well_formed_length */
};


UDM_CHARSET udm_charset_sys_int=
{
  UDM_CHARSET_SYS_INT,
  &udm_charset_handler_sys_int,
  "sys-int", NULL, NULL,
  UDM_CHARSET_UNICODE,
  NULL, /* ctype */
  NULL, /* to_uni */
  NULL, /* from_uni */
};
